# Networks

In general, given an Hilbert space ``\mathcal{H}`` with basis ``\vec\sigma\in\mathcal{H}``, a density matrix defined on this space lives in the space of the Bounded Operators ``\mathcal{B}`` with (overcomplete) basis ``(\sigma, \tilde{\sigma} ) \in \mathcal{H}\otimes\mathcal{H}``.  A network is a (high-dimensional non-linear) function

```math
\rho(\sigma, \tilde\sigma, W)
```
depending on the variational parameters ``W``, and on the entries of the density matrix labelled by ``(\sigma, \tilde\sigma)``.

## Usage
There are currently three implemented networks:

### Neural Density Matrix
Torlai et Melko PRL 2019

A real-valued neural network to describe a positive-semidefinite matrix. Complex numbers are generated by duplicating the structure of the network, and using one to generate the modulus and the other to generate the phase. See the article for details.

```@docs
NDM
```

```@docs
RBMSplit
```

```@docs
RBM
```
